'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Object3D2 = require('./Object3D');

var _Object3D3 = _interopRequireDefault(_Object3D2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Сцена включает в себя все объекты необходимые для рендеринга
 *
 * @extends Object3D
 */

var Scene = function (_Object3D) {
    _inherits(Scene, _Object3D);

    function Scene() {
        _classCallCheck(this, Scene);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Scene).call(this));

        _this._lights = [];
        return _this;
    }

    /**
     * Добавляет источник света на сцену
     * @param {Light} light
     */


    _createClass(Scene, [{
        key: 'addLight',
        value: function addLight(light) {
            this._lights.push(light);

            return this;
        }

        /**
         * Возвращает все источники света сцены
         * @returns {Light[]}
         */

    }, {
        key: 'getLights',
        value: function getLights() {
            return this._lights;
        }
    }]);

    return Scene;
}(_Object3D3.default);

exports.default = Scene;
module.exports = exports['default'];