'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _glMatrix = require('gl-matrix');

var _Camera2 = require('./Camera');

var _Camera3 = _interopRequireDefault(_Camera2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Задаёт орфографическую камеру
 *
 * @extends Camera
 */

var OrthographicCamera = function (_Camera) {
  _inherits(OrthographicCamera, _Camera);

  /**
   * @param {Number} left Левая плоскость камеры
   * @param {Number} right Правая плоскость камеры
   * @param {Number} top Верхняя плоскость камеры
   * @param {Number} bottom Нижняя плоскость камеры
   * @param {Number} near Минимальное расстояние от камеры до объектов, которые будут отображаться
   * @param {Number} far Максимальное расстояние от камеры до объектов, которые будут отображаться
   */

  function OrthographicCamera(left, right, top, bottom, near, far) {
    _classCallCheck(this, OrthographicCamera);

    /**
     * Левая плоскость камеры
     * @type {Number}
     */

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(OrthographicCamera).call(this));

    _this.left = left;

    /**
     * Правая плоскость камеры
     * @type {Number}
     */
    _this.right = right;

    /**
     * Верхняя плоскость камеры
     * @type {Number}
     */
    _this.top = top;

    /**
     * Нижняя плоскость камеры
     * @type {Number}
     */
    _this.bottom = bottom;

    /**
     * Минимальное расстояние от камеры до объектов, которые будут отображаться
     * @type {Number}
     */
    _this.near = near;

    /**
     * Максимальное расстояние от камеры до объектов, которые будут отображаться
     * @type {Number}
     */
    _this.far = far;
    return _this;
  }

  _createClass(OrthographicCamera, [{
    key: 'updateProjectionMatrix',
    value: function updateProjectionMatrix() {
      _glMatrix.mat4.ortho(this.projectionMatrix, this.left, this.right, this.bottom, this.top, this.near, this.far);
    }
  }]);

  return OrthographicCamera;
}(_Camera3.default);

exports.default = OrthographicCamera;
module.exports = exports['default'];