'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _glMatrix = require('gl-matrix');

var _Camera2 = require('./Camera');

var _Camera3 = _interopRequireDefault(_Camera2);

var _Math = require('../math/Math');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Задаёт перспективную камеру
 *
 * @extends Camera
 */

var PerspectiveCamera = function (_Camera) {
  _inherits(PerspectiveCamera, _Camera);

  /**
   * @param {Number} fov Угл обзора камеры в градусах
   * @param {Number} aspect Соотношение сторон
   * @param {Number} near Минимальное расстояние от камеры до объектов, которые будут отображаться
   * @param {Number} far Максимальное расстояние от камеры до объектов, которые будут отображаться
   */

  function PerspectiveCamera(fov, aspect, near, far) {
    _classCallCheck(this, PerspectiveCamera);

    /**
     * Угл обзора камеры в градусах
     * @type {Number}
     */

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(PerspectiveCamera).call(this));

    _this.fov = fov;

    /**
     * Соотношение сторон
     * @type {Number}
     */
    _this.aspect = aspect;

    /**
     * Минимальное расстояние от камеры до объектов, которые будут отображаться
     * @type {Number}
     */
    _this.near = near;

    /**
     * Максимальное расстояние от камеры до объектов, которые будут отображаться
     * @type {Number}
     */
    _this.far = far;
    return _this;
  }

  _createClass(PerspectiveCamera, [{
    key: 'updateProjectionMatrix',
    value: function updateProjectionMatrix() {
      _glMatrix.mat4.perspective(this.projectionMatrix, (0, _Math.degToRad)(this.fov), this.aspect, this.near, this.far);
    }
  }]);

  return PerspectiveCamera;
}(_Camera3.default);

exports.default = PerspectiveCamera;
module.exports = exports['default'];