'use strict';

var _Renderer = require('./renderer/Renderer');

var _Renderer2 = _interopRequireDefault(_Renderer);

var _Object3D = require('./Object3D');

var _Object3D2 = _interopRequireDefault(_Object3D);

var _PerspectiveCamera = require('./cameras/PerspectiveCamera');

var _PerspectiveCamera2 = _interopRequireDefault(_PerspectiveCamera);

var _OrthographicCamera = require('./cameras/OrthographicCamera');

var _OrthographicCamera2 = _interopRequireDefault(_OrthographicCamera);

var _Buffer = require('./Buffer');

var _Buffer2 = _interopRequireDefault(_Buffer);

var _Geometry = require('./Geometry');

var _Geometry2 = _interopRequireDefault(_Geometry);

var _BasicMeshProgram = require('./programs/BasicMeshProgram');

var _BasicMeshProgram2 = _interopRequireDefault(_BasicMeshProgram);

var _ComplexMeshProgram = require('./programs/ComplexMeshProgram');

var _ComplexMeshProgram2 = _interopRequireDefault(_ComplexMeshProgram);

var _SpriteProgram = require('./programs/SpriteProgram');

var _SpriteProgram2 = _interopRequireDefault(_SpriteProgram);

var _Mesh = require('./Mesh');

var _Mesh2 = _interopRequireDefault(_Mesh);

var _Sprite = require('./Sprite');

var _Sprite2 = _interopRequireDefault(_Sprite);

var _Scene = require('./Scene');

var _Scene2 = _interopRequireDefault(_Scene);

var _Texture = require('./Texture');

var _Texture2 = _interopRequireDefault(_Texture);

var _AmbientLight = require('./lights/AmbientLight');

var _AmbientLight2 = _interopRequireDefault(_AmbientLight);

var _DirectionalLight = require('./lights/DirectionalLight');

var _DirectionalLight2 = _interopRequireDefault(_DirectionalLight);

var _Raycaster = require('./Raycaster');

var _Raycaster2 = _interopRequireDefault(_Raycaster);

var _Ray = require('./math/Ray');

var _Ray2 = _interopRequireDefault(_Ray);

var _Plane = require('./math/Plane');

var _Plane2 = _interopRequireDefault(_Plane);

var _Box = require('./math/Box');

var _Box2 = _interopRequireDefault(_Box);

var _Math = require('./math/Math');

var math = _interopRequireWildcard(_Math);

var _Line = require('./math/Line3');

var _Line2 = _interopRequireDefault(_Line);

var _glMatrix = require('gl-matrix');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// with Float32Array we have errors with raycast
_glMatrix.glMatrix.ARRAY_TYPE = typeof Float64Array !== 'undefined' ? Float64Array : Array;

var dgl = {
    Renderer: _Renderer2.default,
    Object3D: _Object3D2.default,
    PerspectiveCamera: _PerspectiveCamera2.default,
    OrthographicCamera: _OrthographicCamera2.default,
    Buffer: _Buffer2.default,
    Geometry: _Geometry2.default,
    Mesh: _Mesh2.default,
    Sprite: _Sprite2.default,
    BasicMeshProgram: _BasicMeshProgram2.default,
    ComplexMeshProgram: _ComplexMeshProgram2.default,
    SpriteProgram: _SpriteProgram2.default,
    Scene: _Scene2.default,
    Texture: _Texture2.default,
    AmbientLight: _AmbientLight2.default,
    DirectionalLight: _DirectionalLight2.default,
    Raycaster: _Raycaster2.default,
    Ray: _Ray2.default,
    Plane: _Plane2.default,
    Box: _Box2.default,
    Line3: _Line2.default,
    Math: math,
    vec3: _glMatrix.vec3,
    mat3: _glMatrix.mat3,
    vec2: _glMatrix.vec2,
    mat4: _glMatrix.mat4,
    quat: _glMatrix.quat
};

module.exports = dgl;