'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _glMatrix = require('gl-matrix');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Объект параллелепипеда
 *
 * Взято из [three.js](https://github.com/mrdoob/three.js/blob/master/src/math/Box3.js)
 */

var Box = function () {
  /**
   * Параллелепипед задаётся двумя точками
   * @param {vec3} min Минимальная
   * @param {vec3} max Максимальная
   */

  function Box(min, max) {
    _classCallCheck(this, Box);

    this.min = min || _glMatrix.vec3.create();
    this.max = max || _glMatrix.vec3.create();
  }

  /**
   * Проверяет содержит ли параллелепипед заданную точку
   * @param {vec3} point
   * @returns {Boolean}
   */


  _createClass(Box, [{
    key: 'containsPoint',
    value: function containsPoint(point) {
      return point[0] > this.min[0] && point[0] < this.max[0] && point[1] > this.min[1] && point[1] < this.max[1] && point[2] > this.min[2] && point[2] < this.max[2];
    }

    /**
     * Расширяет параллелепипед до заданной точки
     * @param {vec3} point
     */

  }, {
    key: 'expandByPoint',
    value: function expandByPoint(point) {
      _glMatrix.vec3.min(this.min, this.min, point);
      _glMatrix.vec3.max(this.max, this.max, point);

      return this;
    }
  }]);

  return Box;
}();

exports.default = Box;
module.exports = exports['default'];