'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _glMatrix = require('gl-matrix');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Задаёт плоскость в трёхмерном пространстве
 *
 * Взято из [three.js](https://github.com/mrdoob/three.js/blob/master/src/math/Plane.js)
 */

var Plane = function () {
  /**
   * @param {vec3} normal Нормаль к плоскости
   * @param {Number} [constant=0] Отрицательное смещение плоскости вдоль нормали
   */

  function Plane(normal, constant) {
    _classCallCheck(this, Plane);

    this.normal = normal || _glMatrix.vec3.create();
    this.constant = constant || 0;
  }

  /**
   * Ищет минимальное расстояние между точкой и плоскостью
   * @param {vec3} point
   * @returns {Number}
   */


  _createClass(Plane, [{
    key: 'distanceToPoint',
    value: function distanceToPoint(point) {
      return _glMatrix.vec3.dot(this.normal, point) + this.constant;
    }
  }]);

  return Plane;
}();

exports.default = Plane;
module.exports = exports['default'];