'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _shaders = require('../shaders');

var _Program2 = require('./Program');

var _Program3 = _interopRequireDefault(_Program2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Простая программа для {@link Mesh}. Раскрашивает весь объект в один заданный цвет.
 * {@link Geometry} меша использующего эту программу должна содержать буфер вершин.
 *
 * @extends Program
 */

var BasicMeshProgram = function (_Program) {
    _inherits(BasicMeshProgram, _Program);

    function BasicMeshProgram() {
        _classCallCheck(this, BasicMeshProgram);

        var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(BasicMeshProgram).call(this));

        _this._attributeList = ['position'];
        _this._uniformList = ['uCamera', 'uPosition', 'uColor', 'uColorAlpha'];
        _this._shader = _shaders.basic;

        /**
         * Цвет в формате RGB
         * @type {Number[]}
         */
        _this.color = [0, 0, 0];
        return _this;
    }

    _createClass(BasicMeshProgram, [{
        key: '_bindUniforms',
        value: function _bindUniforms(_ref) {
            var gl = _ref.gl;
            var camera = _ref.camera;
            var object = _ref.object;

            gl.uniformMatrix4fv(this.uniforms.uPosition, false, new Float32Array(object.worldMatrix));
            gl.uniformMatrix4fv(this.uniforms.uCamera, false, new Float32Array(camera.modelViewMatrix));
            gl.uniform1f(this.uniforms.uColorAlpha, this.opacity);
            gl.uniform3fv(this.uniforms.uColor, this.color);
        }
    }]);

    return BasicMeshProgram;
}(_Program3.default);

exports.default = BasicMeshProgram;
module.exports = exports['default'];