"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Программа для спрайтов. Она не наследуюется от {@link Program}
 * и выполняет только связывание шейдера с униформами.
 * Оставлена для единообразия синтаксиса.
 */

var SpriteProgram = function () {
    function SpriteProgram() {
        _classCallCheck(this, SpriteProgram);

        this.opacity = 1;
        this.smoothing = 0;
        this._texture = null;
    }

    /**
     * Устанавливает текстуру для спрайта
     * @param {Texture} texture
     */


    _createClass(SpriteProgram, [{
        key: "setTexture",
        value: function setTexture(texture) {
            this._texture = texture;

            return this;
        }

        /**
         * Возвращает текущую текстуру
         * @returns {?Texture}
         */

    }, {
        key: "getTexture",
        value: function getTexture() {
            return this._texture;
        }
    }, {
        key: "enable",
        value: function enable(_ref) {
            var gl = _ref.gl;
            var object = _ref.object;
            var uniforms = _ref.uniforms;
            var renderer = _ref.renderer;

            gl.uniform1f(uniforms.uColorAlpha, this.opacity);
            gl.uniform1f(uniforms.uSmoothing, this.smoothing);

            var size = renderer.getSize();
            gl.uniform2f(uniforms.uHalfSize, size[0] / 2, size[1] / 2);
            gl.uniform2f(uniforms.uOffset, object.offset[0], object.offset[1]);
            gl.uniform2f(uniforms.uScale, object.scale[0], object.scale[1]);
            gl.uniform3f(uniforms.uPosition, object.worldMatrix[12], object.worldMatrix[13], object.worldMatrix[14]);

            if (this._texture) {
                this._texture.enable(gl);
            }
        }
    }, {
        key: "disable",
        value: function disable() {}

        /**
         * Вызывается спрайтом, чтобы определить его к специфичному рендеру.
         *
         * @param {TypedObjects} typedObjects
         * @param {Sprite} object
         */

    }, {
        key: "typifyForRender",
        value: function typifyForRender(typedObjects, object) {
            typedObjects.sprites.push(object);
        }
    }]);

    return SpriteProgram;
}();

exports.default = SpriteProgram;
module.exports = exports['default'];