"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 * Отдельный рендер, используется для отрисовки прозрачных объектов.
 * @ignore
 */

var TransparentRenderer = function () {
    function TransparentRenderer() {
        _classCallCheck(this, TransparentRenderer);
    }

    _createClass(TransparentRenderer, [{
        key: "render",
        value: function render(state, renderObjects) {
            var gl = state.gl;

            gl.enable(gl.BLEND);
            gl.blendEquation(gl.FUNC_ADD);
            gl.blendFunc(gl.SRC_ALPHA, gl.ONE_MINUS_SRC_ALPHA);

            gl.blendEquationSeparate(gl.FUNC_ADD, gl.FUNC_ADD);
            gl.blendFuncSeparate(gl.SRC_ALPHA, gl.ONE_MINUS_SRC_ALPHA, gl.ONE, gl.ONE_MINUS_SRC_ALPHA);

            if (state.renderer.sortObjects) {
                renderObjects = this._sortObjects(state, renderObjects);
            }

            renderObjects.forEach(function (object) {
                return object.render(state);
            });
        }
    }, {
        key: "_sortObjects",
        value: function _sortObjects(_ref, renderObjects) {
            var camera = _ref.camera;

            var preparedObjects = renderObjects.map(function (object) {
                return {
                    object: object,
                    z: camera.project(object.getWorldPosition())[2]
                };
            });

            preparedObjects.sort(this._reversePainterSortStable);

            return preparedObjects.map(function (object) {
                return object.object;
            });
        }
    }, {
        key: "_reversePainterSortStable",
        value: function _reversePainterSortStable(a, b) {
            if (a.object.renderOrder !== b.object.renderOrder) {
                return a.object.renderOrder - b.object.renderOrder;
            }

            if (a.z !== b.z) {
                return b.z - a.z;
            }
        }
    }]);

    return TransparentRenderer;
}();

exports.default = TransparentRenderer;
module.exports = exports['default'];